/****************** residues.h .***************/
/*************************** for alphabet datastructure *****************
*************************************************************************/
#if !defined(RESIDUES)
#define RESIDUES

/******************************* PROTEIN ******************************/
/* PROTEIN: macro definitions and static types for amino acid alphabet. */
#define AMINO_ACIDS		"XCGASTNDEQKRHWYFVILMP"

/******* ordering of closely related amino acids.  *******/
                     /* . . . . 5 . . . .10 . . . .15 . . . .20 . . . .25 .*/
#define SREL26_BLSM62 "FYIVYWRKLMQEHYILDESTQKNDMIASRQFWLVEKMVNSNHQHFLAGMFNQ"

		/*       . . . . . . . . . . . . . . . . . . . . . . . . . . */
#define	SRELATE_BLSM62 "FYIVYWRKLMQEHYILDESTQKNDMIASRQFWLVEKMVNSNHQHFLAGMFNQTATNVTSQ"

#define PROT_BLOSUM62          "\
X -9 -9 -9 -9 -9 -9 -9 -9 -9 -9 -9 -9 -9 -9 -9 -9 -9 -9 -9 -9 -9 \
C -9  9 -3  0 -1 -1 -3 -3 -4 -3 -3 -3 -3 -2 -2 -2 -1 -1 -1 -1 -3 \
G -9 -3  6  0  0 -2  0 -1 -2 -2 -2 -2 -2 -2 -3 -3 -3 -4 -4 -3 -2 \
A -9  0  0  4  1  0 -2 -2 -1 -1 -1 -1 -2 -3 -2 -2  0 -1 -1 -1 -1 \
S -9 -1  0  1  4  1  1  0  0  0  0 -1 -1 -3 -2 -2 -2 -2 -2 -1 -1 \
T -9 -1 -2  0  1  5  0 -1 -1 -1 -1 -1 -2 -2 -2 -2  0 -1 -1 -1 -1 \
N -9 -3  0 -2  1  0  6  1  0  0  0  0  1 -4 -2 -3 -3 -3 -3 -2 -2 \
D -9 -3 -1 -2  0 -1  1  6  2  0 -1 -2 -1 -4 -3 -3 -3 -3 -4 -3 -1 \
E -9 -4 -2 -1  0 -1  0  2  5  2  1  0  0 -3 -2 -3 -2 -3 -3 -2 -1 \
Q -9 -3 -2 -1  0 -1  0  0  2  5  1  1  0 -2 -1 -3 -2 -3 -2  0 -1 \
K -9 -3 -2 -1  0 -1  0 -1  1  1  5  2 -1 -3 -2 -3 -2 -3 -2 -1 -1 \
R -9 -3 -2 -1 -1 -1  0 -2  0  1  2  5  0 -3 -2 -3 -3 -3 -2 -1 -2 \
H -9 -3 -2 -2 -1 -2  1 -1  0  0 -1  0  8 -2  2 -1 -3 -3 -3 -2 -2 \
W -9 -2 -2 -3 -3 -2 -4 -4 -3 -2 -3 -3 -2 11  2  1 -3 -3 -2 -1 -4 \
Y -9 -2 -3 -2 -2 -2 -2 -3 -2 -1 -2 -2  2  2  7  3 -1 -1 -1 -1 -3 \
F -9 -2 -3 -2 -2 -2 -3 -3 -3 -3 -3 -3 -1  1  3  6 -1  0  0  0 -4 \
V -9 -1 -3  0 -2  0 -3 -3 -2 -2 -2 -3 -3 -3 -1 -1  4  3  1  1 -2 \
I -9 -1 -4 -1 -2 -1 -3 -3 -3 -3 -3 -3 -3 -3 -1  0  3  4  2  1 -3 \
L -9 -1 -4 -1 -2 -1 -3 -4 -3 -2 -2 -2 -3 -2 -1  0  1  2  4  2 -3 \
M -9 -1 -3 -1 -1 -1 -2 -3 -2  0 -1 -1 -2 -1 -1  0  1  1  2  5 -2 \
P -9 -3 -2 -1 -1 -1 -2 -1 -1 -1 -1 -2 -2 -4 -3 -4 -2 -3 -3 -2  7"
/* X  C  G  A  S  T  N  D  E  Q  K  R  H  W  Y  F  V  I  L  M  P */

#define PAM_AMINO_ACIDS		"XARNDCQEGHILKMFPSTWYV"

#define PROT_PAM120          "\
X -2 -1 -2 -1 -2 -4 -1 -1 -2 -2 -1 -2 -2 -2 -3 -2 -1 -1 -5 -3 -1  \
A -1  3 -3 -1  0 -3 -1  0  1 -3 -1 -3 -2 -2 -4  1  1  1 -7 -4  0  \
R -2 -3  6 -1 -3 -4  1 -3 -4  1 -2 -4  2 -1 -5 -1 -1 -2  1 -5 -3  \
N -1 -1 -1  4  2 -5  0  1  0  2 -2 -4  1 -3 -4 -2  1  0 -4 -2 -3  \
D -2  0 -3  2  5 -7  1  3  0  0 -3 -5 -1 -4 -7 -3  0 -1 -8 -5 -3  \
C -4 -3 -4 -5 -7  9 -7 -7 -4 -4 -3 -7 -7 -6 -6 -4  0 -3 -8 -1 -3  \
Q -1 -1  1  0  1 -7  6  2 -3  3 -3 -2  0 -1 -6  0 -2 -2 -6 -5 -3  \
E -1  0 -3  1  3 -7  2  5 -1 -1 -3 -4 -1 -3 -7 -2 -1 -2 -8 -5 -3  \
G -2  1 -4  0  0 -4 -3 -1  5 -4 -4 -5 -3 -4 -5 -2  1 -1 -8 -6 -2  \
H -2 -3  1  2  0 -4  3 -1 -4  7 -4 -3 -2 -4 -3 -1 -2 -3 -3 -1 -3  \
I -1 -1 -2 -2 -3 -3 -3 -3 -4 -4  6  1 -3  1  0 -3 -2  0 -6 -2  3  \
L -2 -3 -4 -4 -5 -7 -2 -4 -5 -3  1  5 -4  3  0 -3 -4 -3 -3 -2  1  \
K -2 -2  2  1 -1 -7  0 -1 -3 -2 -3 -4  5  0 -7 -2 -1 -1 -5 -5 -4  \
M -2 -2 -1 -3 -4 -6 -1 -3 -4 -4  1  3  0  8 -1 -3 -2 -1 -6 -4  1  \
F -3 -4 -5 -4 -7 -6 -6 -7 -5 -3  0  0 -7 -1  8 -5 -3 -4 -1  4 -3  \
P -2  1 -1 -2 -3 -4  0 -2 -2 -1 -3 -3 -2 -3 -5  6  1 -1 -7 -6 -2  \
S -1  1 -1  1  0  0 -2 -1  1 -2 -2 -4 -1 -2 -3  1  3  2 -2 -3 -2  \
T -1  1 -2  0 -1 -3 -2 -2 -1 -3  0 -3 -1 -1 -4 -1  2  4 -6 -3  0  \
W -5 -7  1 -4 -8 -8 -6 -8 -8 -3 -6 -3 -5 -6 -1 -7 -2 -6 12 -2 -8  \
Y -3 -4 -5 -2 -5 -1 -5 -5 -6 -1 -2 -2 -5 -4  4 -6 -3 -3 -2  8 -3  \
V -1  0 -3 -3 -3 -3 -3 -3 -2 -3  3  1 -4  1 -3 -2 -2  0 -8 -3  5"


#endif 
